<?php
/**
 * Luxeritas WordPress Theme - free/libre wordpress platform
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * @copyright Copyright (C) 2015 Thought is free.
 * @license http://www.gnu.org/licenses/gpl-2.0.html GPL v2 or later
 * @author LunaNuko
 * @link https://thk.kanzae.net/
 * @translators rakeem( http://rakeem.jp/ )
 */

/*
 * TinyMCE ボタン登録
 */

/* TinyMCE Plugin CDN */
//cdn.tinymce.com/4/plugins/table/plugin.min.js
//cdn.tinymce.com/4/plugins/visualblocks/plugin.min.js
//cdn.tinymce.com/4/plugins/searchreplace/plugin.min.js

if( get_user_option( 'rich_editing' ) === 'true' ) {
	add_filter( 'mce_external_plugins', function( $plugins ) {
		$plugins['thk-phrase-button']		= TDEL . '/js/thk-dummy.js';
		$plugins['thk-shortcode-button']	= TDEL . '/js/thk-dummy.js';
		$plugins['thk-blogcard-button']		= TDEL . '/js/thk-dummy.js';
		$plugins['thk-mce-settings-button']	= TDEL . '/js/thk-dummy.js';

		if( !in_array( 'table', $plugins ) )		$plugins['table']         = TDEL . '/js/tinymce/plugins.min.js';
		if( !in_array( 'visualblocks', $plugins ) )	$plugins['visualblocks']  = TDEL . '/js/tinymce/plugins.min.js';
		if( !in_array( 'searchreplace', $plugins ) )	$plugins['searchreplace'] = TDEL . '/js/tinymce/plugins.min.js';

		$plugins['thk_emoji'] = TDEL . '/js/tinymce/thk-emoji.min.js';

		return $plugins;
	}, 536870912 );

	add_filter( 'mce_buttons', function( $buttons ) {
		$buttons_new = array();
		$buttons_array = array(
			"formatselect"		=> true,
			"thk-phrase-button"	=> true,
			"thk-shortcode-button"	=> true,
			"thk-blogcard-button"	=> true,
			"visualblocks"		=> true,
			"bold"			=> true,
			"italic"		=> true,
			"bullist"		=> true,
			"numlist"		=> true,
			"blockquote"		=> true,
			"alignleft"		=> true,
			"aligncenter"		=> true,
			"alignright"		=> true,
			"link"			=> true,
			"unlink"		=> true,
			"table"			=> true,
			"thk_emoji"		=> true,
			"wp_more"		=> true,
			"spellchecker"		=> true,
			"wp_page"		=> true,
			"dfw"			=> true,
			"fullscreen"		=> true,
		);

		foreach( $buttons_array as $key => $val ) {
			$buttons_new[] = $key;
		}
		foreach( $buttons as $val ) {
			if( $val === "wp_adv" || $val === "kitchensink" ) continue;
			if( !isset( $buttons_array[$val] ) ) $buttons_new[] = $val;
		}
		$buttons_new[] = "wp_adv";

		return $buttons_new;
	}, 536870912 );

	add_filter( 'mce_buttons_2', function( $buttons ) {
		$buttons_new = array();
		$buttons_array = array(
			"fontsizeselect"	=> true,
			"fontselect"		=> true,
			"strikethrough"		=> true,
			"underline"		=> true,
			"hr"			=> true,
			"forecolor"		=> true,
			"backcolor"		=> true,
			"pastetext"		=> true,
			"removeformat"		=> true,
			"charmap"		=> true,
			"outdent"		=> true,
			"indent"		=> true,
			"undo"			=> true,
			"redo"			=> true,
			"copy"			=> true,
			"paste"			=> true,
			"cut"			=> true,
			"searchreplace"		=> true,
			"wp_help"		=> true,
			"thk-mce-settings-button" => true,
		);

		foreach( $buttons_array as $key => $val ) {
			$buttons_new[] = $key;
		}
		foreach( $buttons as $val ) {
			if( !isset( $buttons_array[$val] ) ) $buttons_new[] = $val;
		}

		return $buttons_new;
	}, 536870912 );
}

add_action( 'admin_print_scripts', function() {
	wp_localize_script( 'mce-view', '_thkMceViewL10n', array( 'localize' => __( 'Emoji', 'luxeritas' ) ) );
});

add_filter( 'tiny_mce_before_init', function( $settings ) {
	global $luxe;

	$settings['block_formats'] =
		  __( 'Paragraph <p>', 'luxeritas' ) . '=p;'
		. __( 'Block <div>', 'luxeritas' ) . '=div;'
		. __( 'Heading 2 <h2>', 'luxeritas' ) . '=h2;'
		. __( 'Heading 3 <h3>', 'luxeritas' ) . '=h3;'
		. __( 'Heading 4 <h4>', 'luxeritas' ) . '=h4;'
		. __( 'Heading 5 <h5>', 'luxeritas' ) . '=h5;'
		. __( 'Heading 6 <h6>', 'luxeritas' ) . '=h6;'
		. __( 'Blockquote <blockquote>', 'luxeritas' ) . '=blockquote;'
		. __( 'Preformatted <pre>', 'luxeritas' ) . '=pre;'
		. __( 'Address <address>', 'luxeritas' ) . '=address;'
	;

	$settings['fontsize_formats'] =
		  '10px 12px 14px 16px 18px 20px 24px 28px 32px 36px 42px '
		. '0.8em 0.9em 1.0em 1.1em 1.2em 1.3em 1.4em 1.5em 1.6em 1.7em 1.8em 1.9em 2.0em 2.1em 2.2em 2.3em 2.4em';

	$settings['font_formats'] =
		  __( 'Sans-serif', 'luxeritas' ) . '=sans-serif;'
		. __( 'serif', 'luxeritas' ) . '=serif;'
		. __( 'Monospaced font', 'luxeritas' ) . '=Consolas,Courier New,Courier,Lucida Console,Consolas,Inconsolata,Monaco,monospace,MS Gothic,Osaka-Mono;'
		. __( 'Yu Gothic', 'luxeritas' ) . '=Yu Gothic,YuGothic,YuGothicM,sans-serif;'
		. __( 'Yu Mincho', 'luxeritas' ) . '=Yu Mincho,YuMincho,serif;'
		. 'Andale Mono=andale mono,times;'
		. 'Arial=arial,helvetica,sans-serif;'
		. 'Arial Black=arial black,avant garde;'
		. 'Book Antiqua=book antiqua,palatino;'
		. 'Comic Sans MS=comic sans ms,sans-serif;'
		. 'Courier New=courier new,courier;'
		. 'Georgia=georgia,palatino;'
		. 'Helvetica=helvetica;'
		. 'Impact=impact,chicago;'
		. 'Tahoma=tahoma,arial,helvetica,sans-serif;'
		. 'Terminal=terminal,monaco;'
		. 'Times New Roman=times new roman,times;'
		. 'Trebuchet MS=trebuchet ms,geneva;'
		. 'Verdana=verdana,geneva;'
		. 'Webdings=webdings;'
		. 'Wingdings=wingdings,zapf dingbats;'
	;

	//$settings['theme']	= 'modern';
	//$settings['skin']	= 'lightgray';
	//$settings['indent']	= false;
	//$settings['keep_styles']	= false;
	//$settings['wpautop']	= true;
	//$settings['branding']	= false;
	//$settings['wp_autoresize_on'] = true;
	//$settings['wp_keep_scroll_position'] = false;
	//$settings['resize']	= false;
	if( isset( $luxe['mce_menubar'] ) ) {
		$settings['menubar'] = true;
	}
	if( isset( $luxe['mce_enter_key'] ) && $luxe['mce_enter_key'] === 'linefeed' ) {
		$settings['forced_root_block'] = false;
	}
	$settings['body_class']	= 'post';
	$settings['cache_suffix'] = 'v=' . $_SERVER['REQUEST_TIME'];
	$maxwidth = isset( $luxe['mce_max_width'] ) && ctype_digit( (string)$luxe['mce_max_width'] ) && $luxe['mce_max_width'] !== 0 ? $luxe['mce_max_width'] . 'px' : '100%';
	$bg_color = isset( $luxe['mce_bg_color'] ) ? $luxe['mce_bg_color'] : '#fff';
	$color    = isset( $luxe['mce_color'] ) ? $luxe['mce_color'] : '#000';
	$settings['content_style'] = 'body.mceContentBody{max-width:' . $maxwidth . ';background:' . $bg_color . ';color:' . $color . '}';
	return $settings;
});

$turi = get_template_directory_uri() . '/';
$suri = get_stylesheet_directory_uri() . '/';
$editor_css_files = array();

if( file_exists( TPATH . DSEP . 'style.min.css' ) === true ) {
	$editor_css_files[] = $turi . 'style.min.css';
}
else {
	$editor_css_files[] = $turi . 'css/luxe-mode.css';
	$editor_css_files[] = $turi . 'style.css';
}
$editor_css_files[] = $turi . 'editor-style.css';
if( TPATH !== SPATH ) {
	if( isset( $luxe['design_file'] ) ) {
		$design_editor_css = 'design/' . $luxe['design_file'] . '/style.css';
		$design_editor_css = 'design/' . $luxe['design_file'] . '/editor-style.css';
		if( file_exists( SPATH . DSEP . $design_editor_css ) === true ) {
			$editor_css_files[] = $suri . $design_editor_css;
		}
	}
	if( file_exists( SPATH . DSEP . 'style.min.css' ) === true ) {
		$editor_css_files[] = $suri . 'style.min.css';
	}
	else {
		$editor_css_files[] = $suri . 'style.css';
	}
	$editor_css_files[] = $suri . 'editor-style.css';
}
add_editor_style( $editor_css_files );
